/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.personenpruefung;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.personenpruefung.boundary.AbstractPersonPruefungKonfigurationSearchParameters;
import de.ivu.elect.business.personenpruefung.boundary.PersonPruefungKonfigurationChangeEvent;
import de.ivu.elect.business.personenpruefung.boundary.PersonPruefungKonfigurationConversationStore;
import de.ivu.elect.business.personenpruefung.boundary.PersonPruefungKonfigurationExtendedDAO;
import de.ivu.elect.business.personenpruefung.boundary.PersonPruefungKonfigurationSearch;
import de.ivu.elect.business.personenpruefung.boundary.PersonPruefungKonfigurationSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfiguration;
import de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractPersonPruefungKonfigurationSearchView.COMPONENT_NAME)
@View(viewId = AbstractPersonPruefungKonfigurationSearchView.VIEW_ID, useCase = UseCasePermission.PERSON_PRUEFUNG_KONFIGURATION_SEARCH)
public abstract class AbstractPersonPruefungKonfigurationSearchView extends AbstractElectSearchView<PersonPruefungKonfiguration> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "personPruefungKonfigurationSearchView";
  
  public static final String VIEW_ID = "/personenpruefung/person-pruefung-konfiguration-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractPersonPruefungKonfigurationSearchView requestHandler;

  @Inject
  private transient PersonPruefungKonfigurationExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(PersonPruefungKonfigurationConversationStore.class)
  protected transient PersonPruefungKonfigurationConversationStore conversationStore;

  @Inject
  protected transient PersonPruefungKonfigurationSearch search;

  @Inject
  @ConversationGroup(AbstractPersonPruefungKonfigurationSearchParameters.class)
  protected transient PersonPruefungKonfigurationSearchParameters searchParameters;

  @Inject
  protected transient PersonPruefungKonfigurationMeta entityMeta;

  public AbstractPersonPruefungKonfigurationSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public PersonPruefungKonfiguration getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(PersonPruefungKonfiguration entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public PersonPruefungKonfigurationSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<PersonPruefungKonfiguration> getEagerLoadingCollector() {
    return EagerLoadingCollector.<PersonPruefungKonfiguration> create();
  }

  @Override
  public List<PersonPruefungKonfiguration> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<PersonPruefungKonfiguration> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onPersonPruefungKonfigurationChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) PersonPruefungKonfigurationChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  // elect: Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractPersonPruefungKonfigurationSearchView {

    @View
    @Inject
    private transient Instance<AbstractPersonPruefungKonfigurationSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractPersonPruefungKonfigurationSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
